﻿using UnityEngine;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace core
{
    public class ControlIconController : MonoBehaviour
    {
        private bool isOk = false;
        [SerializeField]
        private Animator animator;
        [SerializeField]
        private string inputAxis; // Should match a tentacle, though technically not enforced.
        [SerializeField]
        private KeyCode inputButton; // Use either this or axis
        [SerializeField]
        private KeyCode inputButtonAlt;
        [SerializeField]
        private UnityEngine.UI.Text iconText; // Disable this on OK.
        [SerializeField]
        private AudioSource sfxMenu;

        public delegate void Callback_VoidVoid();
        private Callback_VoidVoid OnControlIconReady;

        public void PrepareToReady(Callback_VoidVoid OnControlIconReady) {
            this.isOk = false;
            this.animator.SetBool("isOk", false);
            this.OnControlIconReady = OnControlIconReady;
            this.iconText.enabled = true;
        }

        public void Update()
        {
            // If prepared
            if (this.OnControlIconReady == null)
                return;

            if (!string.IsNullOrEmpty(this.inputAxis) && Input.GetAxis(this.inputAxis) != 0.0f && !this.isOk ||
                this.inputButton != KeyCode.None      && (Input.GetKeyDown(this.inputButton) || Input.GetKeyDown(this.inputButtonAlt)) && !this.isOk)
            {
                this.isOk = true;
                this.animator.SetBool("isOk", true);
                this.OnControlIconReady();
                this.OnControlIconReady = null;
                this.iconText.enabled = false;
                this.sfxMenu.Play();
            }
        }
    }
}
