﻿using UnityEngine;
using System;
using System.Collections;
using System.Linq;
using System.Text;

namespace sushi
{
    /// <summary>
    /// Can hold one sushi at a time. That sushi must be cut before another can be accepted.
    /// </summary>
    public class TableController : MonoBehaviour
    {
        private const int sushiScore_c = 10; 

        [SerializeField]
        private KeyCode inputButton;
        [SerializeField]
        private KeyCode inputButtonAlt;
        [SerializeField]
        private Animator apprentipusAnimator;
        [SerializeField]
        private AudioSource sfxRightCtrl;
        [SerializeField]
        private AudioSource sfxKnives;

        private GameObject currentSushi; // TODO: Make a bool instead?

        public bool TryGivingSushi(SushiController sushi)
        {
            if (this.currentSushi != null)
                return false;

            this.currentSushi = sushi.gameObject;
            Component.Destroy( sushi );
            Component.Destroy( sushi.GetComponent<Rigidbody>() );
            sushi.transform.position = this.transform.position + new Vector3(0f, 0.5f, 0f);
            sushi.transform.rotation = Quaternion.AngleAxis(90.0f, Vector3.forward);
            this.sfxRightCtrl.Play();
            return true;
        }

        public void Update()
        {
            if (core.Game.game.IsGameOver())
                return;

            if ((Input.GetKeyDown(this.inputButton) || Input.GetKeyDown(this.inputButtonAlt)) && this.currentSushi != null) {
                MonoBehaviour.Destroy(this.currentSushi.gameObject);
                this.currentSushi = null;
                core.Game.game.AddToScore(sushiScore_c);
                this.StopCoroutine(this.AnimateApprentipus());
                this.StartCoroutine(this.AnimateApprentipus());
                this.sfxKnives.Play();
            }
        }

        private IEnumerator AnimateApprentipus()
        {
            // If we need to interrupt the animation to start it over, as it stands, we need to set the animator's state to false and then back to true
            // so that it will transition into the idle state and then back. (In the FUTURE, learn how to interrupt animations.)
            this.apprentipusAnimator.SetBool("isChopping", false);
            yield return null;
            this.apprentipusAnimator.SetBool("isChopping", true);
            yield return new WaitForSeconds(1.0f); // Animation duration
            this.apprentipusAnimator.SetBool("isChopping", false);
        }
    }
}
